package speiger.src.builder.misc;

import java.util.List;
import java.util.Set;

public class RegexUtil
{
	public static String searchUntil(String text, int startIndex, char increase, char decrease)
	{
		if(text.charAt(startIndex + 1) != increase)
		{
			return "";
		}
		int inc = 0;
		StringBuilder builder = new StringBuilder();
		for(int i = startIndex + 1;i<text.length();i++)
		{
			char current = text.charAt(i);
			if(current == '\\' && i < text.length() - 1 && text.charAt(i+1) == 'n')
			{
				return "";
			}
			else if(current == increase)
			{
				inc++;
			}
			else if(current == decrease)
			{
				inc--;
				if(inc <= 0)
				{
					return builder.append(decrease).toString();
				}
			}
			builder.append(current);
		}
		return "";
	}
	
	public static int[] findFullLine(String s, int startIndex)
	{
		int offset = s.indexOf("\n", startIndex);
		if(offset == -1) return null;
		int start = s.lastIndexOf("\n", startIndex);
		if(start == -1) return null;
		return new int[]{start, offset};
	}
	
	public static int lastIndexOf(List<String> list, int startIndex, String increase, String decrease)
	{
		if(!list.get(startIndex).equalsIgnoreCase(increase)) return -1;
		int inc = 0;
		for(int i = startIndex;i<list.size();i++)
		{
			String entry = list.get(i);
			if(entry.equalsIgnoreCase(increase)) inc++;
			else if(entry.equalsIgnoreCase(decrease)) {
				inc--;
				if(inc <= 0) return i;
			}
		}
		return -1;
	}
	
	public static String ensureWhitespaces(String s, Set<Character> set) {
		StringBuilder builder = new StringBuilder(s);
		for(int i = s.length()-1;i>=0;i--) {
			char entry = builder.charAt(i);
			if(entry != ' ' && set.contains(entry)) {
				if(builder.charAt(i+1) != ' ') builder.insert(i+1, ' ');
				if(builder.charAt(i-1) != ' ') builder.insert(i, ' '); 
			}
		}
		return builder.toString();
	}
}	