package speiger.src.builder.processor;

import java.util.List;
import java.util.Map;
import java.util.Set;

import speiger.src.builder.mappers.IMapper;

public class CompiledArguments
{
	List<IMapper> mapper;
	Set<String> flags;
	Map<String, Integer> flaggedValues;
	
	public CompiledArguments(TemplateProcess process)
	{
		mapper = process.mappers;
		flags = process.parsePool;
		flaggedValues = process.parseValues;
	}
	
	public List<IMapper> getMapper()
	{
		return mapper;
	}
	
	public boolean test(String key)
	{
		return flags.contains(key);
	}
	
	public int get(String key)
	{
		return flaggedValues.getOrDefault(key, 0);
	}
}
